<script lang="ts">
	import init, {
		ebnf_to_regex,
		ProgrammingLanguage,
		ebnf_to_code
	} from '@lujobi-projects/ebnf-to-regex';
	import { onMount } from 'svelte';
	import type { PageData } from './$types';

	export let data: PageData;

	let ready = false;

	onMount(() => {
		init().then(() => {
			ready = true;
		});
	});

	let ebnf: string;
	let prog_lang: ProgrammingLanguage | undefined;

	$: error_disp = '';
	$: ebnf_disp = '';
	$: code_disp = '';

	const update = () => {
		if (ready) {
			try {
				ebnf_disp = ebnf_to_regex(ebnf).trim();
				if (prog_lang) {
					code_disp = ebnf_to_code(
						ebnf,
						ProgrammingLanguage[prog_lang] as unknown as number
					).trim();
				}
				error_disp = '';
			} catch (error) {
				error_disp = error as string;
			}
		}
	};
</script>

<div class="flex flex-col space-y-4 ...">
	<h1 class="text-3xl font-bold">EBNF to Regex</h1>

	<textarea
		class="textarea textarea-primary w-full"
		placeholder="EBNF"
		bind:value={ebnf}
		on:input={update}
	/>

	{#if error_disp === ''}
		<div class="mockup-code">
			{#each ebnf_disp.split('\n').map((code, id) => [code, id + 1]) as [code, id]}
				<pre data-prefix={id}><code>{code}</code></pre>
			{/each}
		</div>

		<select class="select select-primary w-full max-w-xs" bind:value={prog_lang} on:change={update}>
			<option disabled selected value={undefined}>Select a programming langugage</option>
			{#each data.programming_languages as lang}
				<option value={lang}>{lang}</option>
			{/each}
		</select>

		<div class="mockup-code">
			{#each code_disp.split('\n').map((code, id) => [code, id + 1]) as [code, id]}
				<pre data-prefix={id}><code>{code}</code></pre>
			{/each}
		</div>
	{:else}
		<div class="alert alert-warning shadow-lg">
			<div>
				<svg
					xmlns="http://www.w3.org/2000/svg"
					class="stroke-current flex-shrink-0 h-6 w-6"
					fill="none"
					viewBox="0 0 24 24"
					><path
						stroke-linecap="round"
						stroke-linejoin="round"
						stroke-width="2"
						d="M12 9v2m0 4h.01m-6.938 4h13.856c1.54 0 2.502-1.667 1.732-3L13.732 4c-.77-1.333-2.694-1.333-3.464 0L3.34 16c-.77 1.333.192 3 1.732 3z"
					/></svg
				>
				<span>{error_disp}</span>
			</div>
		</div>
	{/if}
</div>
